#ifndef _AUDIOSOURCEAC3_H_
#define _AUDIOSOURCEAC3_H_


class AudioSourceAC3 : public vdxunknown<IVDXStreamSource>, public IVDXStreamSourceV3, public IVDXAudioSource
{

public:
	AudioSourceAC3(InputFileAC3 *const pp);
	~AudioSourceAC3();

// IVDXUnknown methods
	int         VDXAPIENTRY AddRef();
	int         VDXAPIENTRY Release();
	void*       VDXAPIENTRY AsInterface(uint32 iid);

// IVDXStreamSource methods
	void        VDXAPIENTRY GetStreamSourceInfo(VDXStreamSourceInfo&);
	bool        VDXAPIENTRY Read(sint64 lStart, uint32 lCount, void *lpBuffer, uint32 cbBuffer, uint32 *lBytesRead, uint32 *lSamplesRead);
	const void* VDXAPIENTRY GetDirectFormat();
	int         VDXAPIENTRY GetDirectFormatLen();
	ErrorMode   VDXAPIENTRY GetDecodeErrorMode();
	void        VDXAPIENTRY SetDecodeErrorMode(ErrorMode mode);
	bool        VDXAPIENTRY IsDecodeErrorModeSupported(ErrorMode mode);
	bool        VDXAPIENTRY IsVBR();
	sint64      VDXAPIENTRY TimeToPositionVBR(sint64 us);
	sint64      VDXAPIENTRY PositionToTimeVBR(sint64 samples);

// IVDXStreamSourceV3 methods
	void        VDXAPIENTRY GetStreamSourceInfoV3(VDXStreamSourceInfoV3&);

// IVDXAudioSource methods
	void        VDXAPIENTRY GetAudioSourceInfo(VDXAudioSourceInfo& info);

protected:
	InputFileAC3* const parentPtr;
	
	WAVEFORMATEX  mRawFormat;
	unsigned long mLength;
	double        mDuration;
	bool          fIsVBR;
};


#endif // _AUDIOSOURCEAC3_H_
