#ifndef _INPUTFILEAC3_H_
#define _INPUTFILEAC3_H_


typedef struct
{
	unsigned __int64  size: 16;
	unsigned __int64  pos : 48;
}
AC3SampleInfo;


class InputFileAC3 : public vdxunknown<IVDXInputFile>
{

public:
// InputFileAC3 methods
	InputFileAC3(const VDXInputDriverContext& context);
	~InputFileAC3();

	static BOOL CALLBACK FindContextWindow(HWND hwnd, LPARAM lParam);

// IVDXInputFile methods
	bool VDXAPIENTRY PromptForOptions(VDXHWND hwndParent, IVDXInputOptions **ppOptions);
	bool VDXAPIENTRY CreateOptions(const void *buf, uint32 len, IVDXInputOptions **ppOptions);

	void VDXAPIENTRY Init(const wchar_t *path, IVDXInputOptions *options);
	bool VDXAPIENTRY Append(const wchar_t *path);

	void VDXAPIENTRY DisplayInfo(VDXHWND hwndParent);

	bool VDXAPIENTRY GetVideoSource(int index, IVDXVideoSource **ppVS);
	bool VDXAPIENTRY GetAudioSource(int index, IVDXAudioSource **ppAS);

	unsigned long frames;
	AC3SampleInfo *framelist;

	int ReadSample(void *buffer, unsigned long sample);

	unsigned long FirstHeader() const { return mFirstHeader; }

protected:
	const VDXInputDriverContext& mContext;

private:
	enum { AC3_HUNT_SIZE = 0x1800 };

	void ByteSwap (void *buffer, int len);
	bool DetectWav(unsigned long& header, int& frmsize);
	int  FirstSync(int& srate, int& chans);
	int  NextSync (int  srate, int  chans);

	bool   guiDlgMessageLoop(HWND hDlg);

	static INT_PTR  CALLBACK ParseDialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

	unsigned long   mFirstHeader;
	WinFile         mFile;
	bool            fAbort;
	bool            fIntel;
	bool            fAc3Wav;
};


#endif // _INPUTFILEAC3_H_
